;************************************************************************
;
;	J[l
;
;************************************************************************

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		KERNEL_LOAD						; J[l̃[hAhX

[BITS 32]
;************************************************************************
;	Gg|Cg
;************************************************************************
kernel:
		;---------------------------------------
		; tHgAhX擾
		;---------------------------------------
		mov		esi, BOOT_LOAD + SECT_SIZE		; ESI   = 0x7C00 + 512
		movzx	eax, word [esi + 0]				; EAX   = [ESI + 0] // ZOg
		movzx	ebx, word [esi + 2]				; EBX   = [ESI + 2] // ItZbg
		shl		eax, 4							; EAX <<= 4;
		add		eax, ebx						; EAX  += EBX;
		mov		[FONT_ADR], eax					; FONT_ADR[0] = EAX;

		;---------------------------------------
		; 
		;---------------------------------------
		cdecl	init_int						; // 荞݃xN^̏
		cdecl	init_pic						; // 荞݃Rg[̏

		set_vect	0x00, int_zero_div			; // 荞ݏ̓o^F0Z
		set_vect	0x21, int_keyboard			; // 荞ݏ̓o^FKBC
		set_vect	0x28, int_rtc				; // 荞ݏ̓o^FRTC

		;---------------------------------------
		; foCX̊荞݋
		;---------------------------------------
		cdecl	rtc_int_en, 0x10				; rtc_int_en(UIE); // XVTCNI荞݋

		;---------------------------------------
		; IMR(荞݃}XNWX^)̐ݒ
		;---------------------------------------
		outp	0x21, 0b_1111_1001				; // 荞ݗLFX[uPIC/KBC
		outp	0xA1, 0b_1111_1110				; // 荞ݗLFRTC

		;---------------------------------------
		; CPŮ荞݋
		;---------------------------------------
		sti										; // 荞݋

		;---------------------------------------
		; tHg̈ꗗ\
		;---------------------------------------
		cdecl	draw_font, 63, 13				; // tHg̈ꗗ\
		cdecl	draw_color_bar, 63, 4			; // J[o[̕\

		;---------------------------------------
		; ̕\
		;---------------------------------------
		cdecl	draw_str, 25, 14, 0x010F, .s0	; draw_str();

.10L:											; while (;;)
												; {
		;---------------------------------------
		; ̕\
		;---------------------------------------
		mov		eax, [RTC_TIME]					;   // ̎擾
		cdecl	draw_time, 72, 0, 0x0700, eax	;   // ̕\

		;---------------------------------------
		; L[R[h̎擾
		;---------------------------------------
		cdecl	ring_rd, _KEY_BUFF, .int_key	;   EAX = ring_rd(buff, &int_key);
		cmp		eax, 0							;   if (EAX == 0)
		je		.10E							;   {
												;   
		;---------------------------------------
		; L[R[h̕\
		;---------------------------------------
		cdecl	draw_key, 2, 29, _KEY_BUFF		;     ring_show(key_buff); // Svf\
.10E:											;   }
		jmp		.10L							; }

.s0:	db	" Hello, kernel! ", 0

ALIGN 4, db 0
.int_key:	dd	0

ALIGN 4, db 0
FONT_ADR:	dd	0
RTC_TIME:	dd	0

;************************************************************************
;	W[
;************************************************************************
%include	"../modules/protect/vga.s"
%include	"../modules/protect/draw_char.s"
%include	"../modules/protect/draw_font.s"
%include	"../modules/protect/draw_str.s"
%include	"../modules/protect/draw_color_bar.s"
%include	"../modules/protect/draw_pixel.s"
%include	"../modules/protect/draw_line.s"
%include	"../modules/protect/draw_rect.s"
%include	"../modules/protect/itoa.s"
%include	"../modules/protect/rtc.s"
%include	"../modules/protect/draw_time.s"
%include	"../modules/protect/interrupt.s"
%include	"../modules/protect/pic.s"
%include	"../modules/protect/int_rtc.s"
%include	"../modules/protect/int_keyboard.s"
%include	"../modules/protect/ring_buff.s"

;************************************************************************
;	pfBO
;************************************************************************
		times KERNEL_SIZE - ($ - $$) db 0x00	; pfBO

