;************************************************************************
;
;	J[l
;
;************************************************************************

%define	USE_SYSTEM_CALL
%define	USE_TEST_AND_SET

;************************************************************************
;	}N
;************************************************************************
%include	"../include/define.s"
%include	"../include/macro.s"

		ORG		KERNEL_LOAD						; J[l̃[hAhX

[BITS 32]
;************************************************************************
;	Gg|Cg
;************************************************************************
kernel:
		;---------------------------------------
		; tHgAhX擾
		;---------------------------------------
		mov		esi, BOOT_LOAD + SECT_SIZE		; ESI   = 0x7C00 + 512
		movzx	eax, word [esi + 0]				; EAX   = [ESI + 0] // ZOg
		movzx	ebx, word [esi + 2]				; EBX   = [ESI + 2] // ItZbg
		shl		eax, 4							; EAX <<= 4;
		add		eax, ebx						; EAX  += EBX;
		mov		[FONT_ADR], eax					; FONT_ADR[0] = EAX;

		;---------------------------------------
		; TSSfBXNv^̐ݒ
		;---------------------------------------
		set_desc	GDT.tss_0, TSS_0			; // ^XN0pTSS̐ݒ
		set_desc	GDT.tss_1, TSS_1			; // ^XN1pTSS̐ݒ
		set_desc	GDT.tss_2, TSS_2			; // ^XN2pTSS̐ݒ
		set_desc	GDT.tss_3, TSS_3			; // ^XN3pTSS̐ݒ
		set_desc	GDT.tss_4, TSS_4			; // ^XN4pTSS̐ݒ
		set_desc	GDT.tss_5, TSS_5			; // ^XN5pTSS̐ݒ
		set_desc	GDT.tss_6, TSS_6			; // ^XN6pTSS̐ݒ

		;---------------------------------------
		; R[Q[g̐ݒ
		;---------------------------------------
		set_gate	GDT.call_gate, call_gate	; // R[Q[g̐ݒ

		;---------------------------------------
		; LDT̐ݒ
		;---------------------------------------
		set_desc	GDT.ldt, LDT, word LDT_LIMIT

		;---------------------------------------
		; GDT[hiĐݒj
		;---------------------------------------
		lgdt	[GDTR]							; // O[ofBXNv^e[u[h

		;---------------------------------------
		; X^bN̐ݒ
		;---------------------------------------
		mov		esp, SP_TASK_0					; // ^XN0p̃X^bNݒ

		;---------------------------------------
		; ^XNWX^̏
		;---------------------------------------
		mov		ax, SS_TASK_0
		ltr		ax								; // ^XNWX^̐ݒ

		;---------------------------------------
		; 
		;---------------------------------------
		cdecl	init_int						; // 荞݃xN^̏
		cdecl	init_pic						; // 荞݃Rg[̏
		cdecl	init_page						; // y[WȌ

		set_vect	0x00, int_zero_div			; // 荞ݏ̓o^F0Z
		set_vect	0x07, int_nm				; // 荞ݏ̓o^FfoCXgps
		set_vect	0x0E, int_pf				; // 荞ݏ̓o^Fy[WtHg
		set_vect	0x20, int_timer				; // 荞ݏ̓o^F^C}[
		set_vect	0x21, int_keyboard			; // 荞ݏ̓o^FKBC
		set_vect	0x28, int_rtc				; // 荞ݏ̓o^FRTC
		set_vect	0x81, trap_gate_81, word 0xEF00	; // gbvQ[g̓o^F1o
		set_vect	0x82, trap_gate_82, word 0xEF00	; // gbvQ[g̓o^F_̕`

		;---------------------------------------
		; foCX̊荞݋
		;---------------------------------------
		cdecl	rtc_int_en, 0x10				; rtc_int_en(UIE); // XVTCNI荞݋
		cdecl	int_en_timer0					; // ^C}[iJE^0j荞݋

		;---------------------------------------
		; IMR(荞݃}XNWX^)̐ݒ
		;---------------------------------------
		outp	0x21, 0b_1111_1000				; // 荞ݗLFX[uPIC/KBC/^C}[
		outp	0xA1, 0b_1111_1110				; // 荞ݗLFRTC

		;---------------------------------------
		; y[WOL
		;---------------------------------------
		mov		eax, CR3_BASE					;
		mov		cr3, eax						; // y[We[u̓o^

		mov		eax, cr0						; // PGrbgZbg
		or		eax, (1 << 31)					; CR0 |= PG;
		mov		cr0, eax						; 
		jmp		$ + 2							; FLUSH();

		;---------------------------------------
		; CPŮ荞݋
		;---------------------------------------
		sti										; // 荞݋

		;---------------------------------------
		; tHg̈ꗗ\
		;---------------------------------------
		cdecl	draw_font, 63, 13				; // tHg̈ꗗ\
		cdecl	draw_color_bar, 63, 4			; // J[o[̕\

		;---------------------------------------
		; ̕\
		;---------------------------------------
		cdecl	draw_str, 25, 14, 0x010F, .s0	; draw_str();

.10L:											; while (;;)
												; {
		;---------------------------------------
		; ]_\
		;---------------------------------------
		cdecl	draw_rotation_bar				;   // ]_\

		;---------------------------------------
		; L[R[h̎擾
		;---------------------------------------
		cdecl	ring_rd, _KEY_BUFF, .int_key	;   EAX = ring_rd(buff, &int_key);
		cmp		eax, 0							;   if (EAX == 0)
		je		.10E							;   {
												;   
		;---------------------------------------
		; L[R[h̕\
		;---------------------------------------
		cdecl	draw_key, 2, 29, _KEY_BUFF		;     ring_show(key_buff); // Svf\

		;---------------------------------------
		; L[̏
		;---------------------------------------
		mov		al, [.int_key]					;     AL = [.int_key]; // L[R[h
		cmp		al, 0x02						;     if ('1' == AL)
		jne		.12E							;     {

		;---------------------------------------
		; t@Cǂݍ
		;---------------------------------------
		call	[BOOT_LOAD + BOOT_SIZE - 16]	;       // t@Cǂݍ

		;---------------------------------------
		; t@C̓e\
		;---------------------------------------
		mov		esi, 0x7800						;       ESI       = ǂݍݐAhX;
		mov		[esi + 32], byte 0				;       [ESI +32] = 0; // ő32
		cdecl	draw_str, 0, 0, 0x0F04, esi		;       draw_str();    // ̕\
.12E:											;     }

		;---------------------------------------
		; CTRL+ALD+ENDL[
		;---------------------------------------
		mov		al, [.int_key]					;     AL  = [.int_key]; // L[R[h
		cdecl	ctrl_alt_end, eax				;     EAX = ctrl_alt_end(L[R[h);
		cmp		eax, 0							;     if (0 != EAX)
		je		.14E							;     {
												;       
		mov		eax, 0							;       // df͈xs
		bts		[.once], eax					;       if (0 == bts(.once))
		jc		.14E							;       {
		cdecl	power_off						;         power_off(); // df
												;       }
.14E:											;     }
.10E:											;   }
		jmp		.10L							; }

.s0:	db	" Hello, kernel! ", 0

ALIGN 4, db 0
.int_key:	dd	0
.once:		dd	0

ALIGN 4, db 0
FONT_ADR:	dd	0
RTC_TIME:	dd	0

;************************************************************************
;	^XN
;************************************************************************
%include	"descriptor.s"
%include	"modules/paging.s"
%include	"modules/int_timer.s"
%include	"modules/int_pf.s"
%include	"tasks/task_1.s"
%include	"tasks/task_2.s"
%include	"tasks/task_3.s"

;************************************************************************
;	W[
;************************************************************************
%include	"../modules/protect/vga.s"
%include	"../modules/protect/draw_char.s"
%include	"../modules/protect/draw_font.s"
%include	"../modules/protect/draw_str.s"
%include	"../modules/protect/draw_color_bar.s"
%include	"../modules/protect/draw_pixel.s"
%include	"../modules/protect/draw_line.s"
%include	"../modules/protect/draw_rect.s"
%include	"../modules/protect/itoa.s"
%include	"../modules/protect/rtc.s"
%include	"../modules/protect/draw_time.s"
%include	"../modules/protect/interrupt.s"
%include	"../modules/protect/pic.s"
%include	"../modules/protect/int_rtc.s"
%include	"../modules/protect/int_keyboard.s"
%include	"../modules/protect/ring_buff.s"
%include	"../modules/protect/timer.s"
%include	"../modules/protect/draw_rotation_bar.s"
%include	"../modules/protect/call_gate.s"
%include	"../modules/protect/trap_gate.s"
%include	"../modules/protect/test_and_set.s"
%include	"../modules/protect/int_nm.s"
%include	"../modules/protect/wait_tick.s"
%include	"../modules/protect/memcpy.s"
%include	"../modules/protect/ctrl_alt_end.s"
%include	"../modules/protect/power_off.s"
%include	"../modules/protect/acpi_find.s"
%include	"../modules/protect/find_rsdt_entry.s"
%include	"../modules/protect/acpi_package_value.s"

;************************************************************************
;	pfBO
;************************************************************************
		times KERNEL_SIZE - ($ - $$) db 0x00	; pfBO

;************************************************************************
;	FAT
;************************************************************************
%include	"fat.s"

